
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Discount_codesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const discount_codes = await db.discount_codes.create(
            {
                id: data.id || undefined,
        
        code: data.code
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        discount_type: data.discount_type
        ||
        null
            ,
            
        value_amount: data.value_amount
        ||
        null
            ,
            
        minimum_order_amount: data.minimum_order_amount
        ||
        null
            ,
            
        usage_limit: data.usage_limit
        ||
        null
            ,
            
        usage_count: data.usage_count
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
        starts_at: data.starts_at
        ||
        null
            ,
            
        ends_at: data.ends_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return discount_codes;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const discount_codesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                code: item.code
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                discount_type: item.discount_type
            ||
            null
            ,
            
                value_amount: item.value_amount
            ||
            null
            ,
            
                minimum_order_amount: item.minimum_order_amount
            ||
            null
            ,
            
                usage_limit: item.usage_limit
            ||
            null
            ,
            
                usage_count: item.usage_count
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
                starts_at: item.starts_at
            ||
            null
            ,
            
                ends_at: item.ends_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const discount_codes = await db.discount_codes.bulkCreate(discount_codesData, { transaction });

        // For each item created, replace relation files
        

        return discount_codes;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const discount_codes = await db.discount_codes.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.code !== undefined) updatePayload.code = data.code;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.discount_type !== undefined) updatePayload.discount_type = data.discount_type;
        
        
        if (data.value_amount !== undefined) updatePayload.value_amount = data.value_amount;
        
        
        if (data.minimum_order_amount !== undefined) updatePayload.minimum_order_amount = data.minimum_order_amount;
        
        
        if (data.usage_limit !== undefined) updatePayload.usage_limit = data.usage_limit;
        
        
        if (data.usage_count !== undefined) updatePayload.usage_count = data.usage_count;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        if (data.starts_at !== undefined) updatePayload.starts_at = data.starts_at;
        
        
        if (data.ends_at !== undefined) updatePayload.ends_at = data.ends_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await discount_codes.update(updatePayload, {transaction});

        
        

        
        

        

        return discount_codes;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const discount_codes = await db.discount_codes.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of discount_codes) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of discount_codes) {
                await record.destroy({transaction});
            }
        });


        return discount_codes;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const discount_codes = await db.discount_codes.findByPk(id, options);

        await discount_codes.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await discount_codes.destroy({
            transaction
        });

        return discount_codes;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const discount_codes = await db.discount_codes.findOne(
            { where },
            { transaction },
        );

        if (!discount_codes) {
            return discount_codes;
        }

        const output = discount_codes.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'discount_codes',
                        'code',
                        filter.code,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'discount_codes',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            starts_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    ends_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.value_amountRange) {
                const [start, end] = filter.value_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    value_amount: {
                    ...where.value_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    value_amount: {
                    ...where.value_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.minimum_order_amountRange) {
                const [start, end] = filter.minimum_order_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    minimum_order_amount: {
                    ...where.minimum_order_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    minimum_order_amount: {
                    ...where.minimum_order_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.usage_limitRange) {
                const [start, end] = filter.usage_limitRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    usage_limit: {
                    ...where.usage_limit,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    usage_limit: {
                    ...where.usage_limit,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.usage_countRange) {
                const [start, end] = filter.usage_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    usage_count: {
                    ...where.usage_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    usage_count: {
                    ...where.usage_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.starts_atRange) {
                const [start, end] = filter.starts_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    starts_at: {
                    ...where.starts_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    starts_at: {
                    ...where.starts_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.ends_atRange) {
                const [start, end] = filter.ends_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    ends_at: {
                    ...where.ends_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    ends_at: {
                    ...where.ends_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.discount_type) {
                where = {
                    ...where,
                discount_type: filter.discount_type,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.discount_codes.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'discount_codes',
                        'code',
                        query,
                    ),
                ],
            };
        }

        const records = await db.discount_codes.findAll({
            attributes: [ 'id', 'code' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['code', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.code,
        }));
    }

    
};

